public class Queue {

    Object[] data;
    int start, end;

    public Queue() {
	this.data = new Object[30];
	start = 0;
	end = 0;
    }

    public synchronized boolean isEmpty() {
	return start == end;
    }

    public synchronized boolean isFull() {
	return start == (end + 1) % data.length;
    }

    public synchronized void queue(Object o) throws InterruptedException {
	while(isFull())
	    this.wait();
	data[start] = 0;
	start = (start + 1) % data.length;
	this.notifyAll();
    }

    public synchronized Object dequeue() throws InterruptedException {
	Object o;
	while(isEmpty())
	    this.wait();
	o = data[end];
	end = (end + 1) % data.length;
	this.notifyAll();
	return o;
    }

}